# NWidgetBase Class Reference
[Hierarchical widgets]

Baseclass for nested widgets. More...

`#include <widget_type.h>`

Inheritance diagram for NWidgetBase:

## Public Member Functions
| NWidgetBase (WidgetType tp)
| Base class constructor.
virtual void | SetupSmallestSize (Window *w, bool init_array)=0
| Compute smallest size needed by the widget.
virtual void | AssignSizePosition (SizingType sizing, uint x, uint y, uint given_width, uint given_height, bool rtl)=0
| Assign size and position to the widget.
virtual void | FillNestedArray (NWidgetBase **array, uint length)=0
virtual NWidgetCore * | GetWidgetFromPos (int x, int y)=0
| Retrieve a widget by its position.
virtual NWidgetBase * | GetWidgetOfType (WidgetType tp)
| Retrieve a widget by its type.
void | SetPadding (uint8 top, uint8 right, uint8 bottom, uint8 left)
| Set additional space (padding) around the widget.
uint | GetHorizontalStepSize (SizingType sizing) const
| Get the horizontal sizing step.
uint | GetVerticalStepSize (SizingType sizing) const
| Get the vertical sizing step.
virtual void | Draw (const Window *w)=0
| Draw the widgets of the tree.
virtual void | SetDirty (const Window *w) const
| Mark the widget as 'dirty' (in need of repaint).
## Data Fields
WidgetType | type
| Type of the widget / nested widget.
uint | fill_x
| Horizontal fill stepsize (from initial size, `0` means not resizable).
uint | fill_y
| Vertical fill stepsize (from initial size, `0` means not resizable).
uint | resize_x
| Horizontal resize step (`0` means not resizable).
uint | resize_y
| Vertical resize step (`0` means not resizable).
uint | smallest_x
| Smallest horizontal size of the widget in a filled window.
uint | smallest_y
| Smallest vertical size of the widget in a filled window.
uint | current_x
| Current horizontal size (after resizing).
uint | current_y
| Current vertical size (after resizing).
uint | pos_x
| Horizontal position of top-left corner of the widget in the window.
uint | pos_y
| Vertical position of top-left corner of the widget in the window.
NWidgetBase * | next
| Pointer to next widget in container. Managed by parent container widget.
NWidgetBase * | prev
| Pointer to previous widget in container. Managed by parent container widget.
uint8 | padding_top
| Paddings added to the top of the widget. Managed by parent container widget.
uint8 | padding_right
| Paddings added to the right of the widget. Managed by parent container widget.
uint8 | padding_bottom
| Paddings added to the bottom of the widget. Managed by parent container widget.
uint8 | padding_left
| Paddings added to the left of the widget. Managed by parent container widget.
## Protected Member Functions
void | StoreSizePosition (SizingType sizing, uint x, uint y, uint given_width, uint given_height)
| Store size and position.

## Detailed Description

Baseclass for nested widgets.

Invariant:
  After initialization, .
  After initialization, .

Definition at line 122 of file widget_type.h.

## Constructor & Destructor Documentation

NWidgetBase::NWidgetBase | ( | WidgetType | tp | ) |

Base class constructor.

Parameters:

  | tp | Nested widget type.

Definition at line 653 of file widget.cpp.

References type.

## Member Function Documentation

void NWidgetBase::AssignSizePosition | ( | SizingType | sizing,
|  | uint | x,
|  | uint | y,
|  | uint | given_width,
|  | uint | given_height,
|  | bool | rtl |
| ) |  |  | `[pure virtual]`

Assign size and position to the widget.

Parameters:

  | sizing | Type of resizing to perform.
  | x | Horizontal offset of the widget relative to the left edge of the window.
  | y | Vertical offset of the widget relative to the top edge of the window.
  | given_width | Width allocated to the widget.
  | given_height | Height allocated to the widget.
  | rtl | Adapt for right-to-left languages (position contents of horizontal containers backwards).

Afterwards, pos_x and pos_y contain the top-left position of the widget, smallest_x and smallest_y contain the smallest size such that all widgets of the window are consistent, and current_x and current_y contain the current size.

Implemented in NWidgetServerListHeader, NWidgetSmallmapDisplay, NWidgetToolbarContainer, NWidgetResizeBase, NWidgetStacked, NWidgetHorizontal, NWidgetHorizontalLTR, NWidgetVertical, and NWidgetBackground.

Referenced by NWidgetBackground::AssignSizePosition(), NWidgetHorizontal::AssignSizePosition(), NWidgetToolbarContainer::AssignSizePosition(), NWidgetSmallmapDisplay::AssignSizePosition(), NWidgetServerListHeader::AssignSizePosition(), Window::InitializeData(), Window::ReInit(), and ResizeWindow().

void NWidgetBase::Draw | ( | const Window * | w | ) | `[pure virtual]`

Draw the widgets of the tree.

The function calls Window::DrawWidget for each widget with a non-negative index, after the widget itself is painted.

Parameters:

  | w | Window that owns the tree.

Implemented in NWidgetServerListHeader, NWidgetSmallmapDisplay, NWidgetToolbarContainer, NWidgetStacked, NWidgetPIPContainer, NWidgetSpacer, NWidgetBackground, NWidgetViewport, and NWidgetLeaf.

Referenced by NWidgetToolbarContainer::Draw(), and Window::DrawWidgets().

uint NWidgetBase::GetHorizontalStepSize | ( | SizingType | sizing | ) | const`[inline]`

Get the horizontal sizing step.

Parameters:

  | sizing | Type of resize being performed.

Definition at line 188 of file widget_type.h.

References fill_x, resize_x, and ST_RESIZE.

uint NWidgetBase::GetVerticalStepSize | ( | SizingType | sizing | ) | const`[inline]`

Get the vertical sizing step.

Parameters:

  | sizing | Type of resize being performed.

Definition at line 197 of file widget_type.h.

References fill_y, resize_y, and ST_RESIZE.

NWidgetCore * NWidgetBase::GetWidgetFromPos | ( | int | x,
|  | int | y |
| ) |  |  | `[pure virtual]`

Retrieve a widget by its position.

Parameters:

  | x | Horizontal position relative to the left edge of the window.
  | y | Vertical position relative to the top edge of the window.

Returns:
  Returns the deepest nested widget that covers the given position, or `NULL` if no widget can be found.

Implemented in NWidgetServerListHeader, NWidgetSmallmapDisplay, NWidgetToolbarContainer, NWidgetCore, NWidgetStacked, NWidgetPIPContainer, NWidgetSpacer, and NWidgetBackground.

Referenced by DispatchLeftClickEvent(), DispatchRightClickEvent(), and GetWidgetFromPos().

NWidgetBase * NWidgetBase::GetWidgetOfType | ( | WidgetType | tp | ) | `[virtual]`

Retrieve a widget by its type.

Parameters:

  | tp | Widget type to search for.

Returns:
  Returns the first widget of the specified type, or `NULL` if no widget can be found.

Reimplemented in NWidgetContainer, and NWidgetBackground.

Definition at line 747 of file widget.cpp.

References type.

Referenced by NWidgetContainer::GetWidgetOfType(), and Window::InitializeData().

void NWidgetBase::SetDirty | ( | const Window * | w | ) | const`[virtual]`

Mark the widget as 'dirty' (in need of repaint).

Parameters:

  | w | Window owning the widget.

Reimplemented in NWidgetSpacer.

Definition at line 727 of file widget.cpp.

References current_x, current_y, Window::left, pos_x, pos_y, SetDirtyBlocks(), and Window::top.

Referenced by DispatchLeftClickEvent(), VehicleListWindow::OnPaint(), Window::SetFocusedWidget(), SetFocusedWindow(), Window::SetWidgetDirty(), and Window::UnfocusFocusedWidget().

void NWidgetBase::SetPadding | ( | uint8 | top,
|  | uint8 | right,
|  | uint8 | bottom,
|  | uint8 | left |
| ) |  |  | `[inline]`

Set additional space (padding) around the widget.

Parameters:

  | top | Amount of additional space above the widget.
  | right | Amount of additional space right of the widget.
  | bottom | Amount of additional space below the widget.
  | left | Amount of additional space left of the widget.

Definition at line 141 of file widget_type.h.

References padding_bottom, padding_left, padding_right, and padding_top.

void NWidgetBase::SetupSmallestSize | ( | Window * | w,
|  | bool | init_array |
| ) |  |  | `[pure virtual]`

Compute smallest size needed by the widget.

The smallest size of a widget is the smallest size that a widget needs to display itself properly. In addition, filling and resizing of the widget are computed. The function calls Window::UpdateWidgetSize for each leaf widget and background widget without child with a non-negative index.

Parameters:

  | w | Window owning the widget.
  | init_array | Initialize the `w->nested_array`.

Note:
  After the computation, the results can be queried by accessing the smallest_x and smallest_y data members of the widget.

Implemented in NWidgetServerListHeader, NWidgetSmallmapDisplay, NWidgetToolbarContainer, NWidgetScenarioToolbarContainer, NWidgetStacked, NWidgetHorizontal, NWidgetVertical, NWidgetSpacer, NWidgetBackground, NWidgetViewport, and NWidgetLeaf.

Referenced by Window::InitializeData(), Window::ReInit(), NWidgetBackground::SetupSmallestSize(), and NWidgetSmallmapDisplay::SetupSmallestSize().

void NWidgetBase::StoreSizePosition | ( | SizingType | sizing,
|  | uint | x,
|  | uint | y,
|  | uint | given_width,
|  | uint | given_height |
| ) |  |  | `[inline, protected]`

Store size and position.

Parameters:

  | sizing | Type of resizing to perform.
  | x | Horizontal offset of the widget relative to the left edge of the window.
  | y | Vertical offset of the widget relative to the top edge of the window.
  | given_width | Width allocated to the widget.
  | given_height | Height allocated to the widget.

Definition at line 704 of file widget.cpp.

References current_x, current_y, pos_x, pos_y, smallest_x, smallest_y, and ST_SMALLEST.

Referenced by NWidgetBackground::AssignSizePosition(), NWidgetVertical::AssignSizePosition(), NWidgetHorizontal::AssignSizePosition(), NWidgetStacked::AssignSizePosition(), and NWidgetResizeBase::AssignSizePosition().

The documentation for this class was generated from the following files:

- src/widget_type.h
- src/widget.cpp